;;  Adding PG for AutoCAD r14 12/08/97
;; 15/07/99  AutoCAD r15 (2000)
;;-----------------------------------------------------------------
;; ----------------------------------------------------------------
;;                       
;;                 
;;   .                   
;;       "hidden" ( ).         
;;                                                                 
;;         ,            
;;        .                          
;;                                                                 
;;       ,   ,      
;;        .             
;;                                                               
;;             
;;        <RETURN>       
;;-----------------------------------------------------------------
;;     -  "" - < 1988                
;;   English version return by G.E.Pospelov -< 1993 .      
;;-----------------------------------------------------------------
;;--------- TRIMHALF.LSP  by G.E.Pospelov  < 1993 .
;;--------- CONCEAL.LSP   basic by Sinom Jones   < 1987 .
;;
;;   Copyright  \"SingleSoft PG\" "
;;                       mailto:gepos@mail.ru 
;;---------------------------------------------------------------------------------------------
;;-----------> 24-09-2002 <--------------------------------------------------------------------
;;           kos@ring.by
;;        TRIMHALF.
;;     :
;;  1. trimhalf.lsp - ,     
;;   ($getLayerName currLayerName)   ,     .
;;  2. trimhalf.dcl -   ,       
;;      .      , 
;;       AutoCAD (    Support).
;;
;;
;;
;;------------------------------------------------------------------------
;;------------------------------------------------------------------------
;;------------------------------------------------------------------------------
(defun $getLayerName (currLayerName / layerInfo listOfLayers present pos dcl_id num)

  (if (< (setq dcl_id (load_dialog "trimhalf.dcl")) 0) (exit))
  (if (not (new_dialog "trimhalf" dcl_id)) (exit))

;;; ----    ,    ----
  (setq layerInfo (tblnext "LAYER" T))
  (while layerInfo
    (setq listOfLayers (cons (cdr (assoc 2 layerInfo)) listOfLayers))
    (setq layerInfo (tblnext "LAYER"))
  ) ;_ while
  (setq listOfLayers (acad_strlsort listOfLayers))
;;; ---- end ----

;;; ----         ----
  (if (member currLayerName listOfLayers)
    (setq present T
	  pos	  (vl-position currLayerName listOfLayers) ;  
    ) ;_ setq
    (setq present nil)
  ) ;_ if
;;; ---- end ----

  (start_list "listOfLayers")
  (mapcar 'add_list listOfLayers)
  (end_list)

  (set_tile "listOfLayers" (itoa pos))

  (action_tile "accept" "(setq num (get_tile \"listOfLayers\"))(done_dialog)")
  (action_tile "cancel" "(setq num (itoa pos))(done_dialog)")

  (start_dialog)
  (unload_dialog dcl_id)

  (nth (atoi num) listOfLayers)
  
) ;_ defun
;;------------------------------------------------------------------------------
;;ERROR FUNCTION
(defun *error*(msg)
 (setq msg "Function Aborting by User")
 (princ)
 (princ msg)
 (princ)
)
;
;;------------------------------------------------------------------------
;    
(defun MODES (a)
   (setq MLST '())
   (repeat (length a)
      (setq MLST (append MLST (list (list (car a) (getvar (car a))))))
      (setq a (cdr a)))
)
;;------------------------------------------------------------------------
;    
(defun MODER ()
   (repeat (length MLST)
      (setvar (caar MLST) (cadar MLST))
      (setq MLST (cdr MLST))
   )
)
;;------------------------------------------------------------------------
;   
(defun XARC (/ cen r)
    (command "LAYER" "S" lln "")
    (setq a (cdr (assoc 50 e1)))
    (setq b (cdr (assoc 51 e1)))
    (setq cen (cdr (assoc 10 e1)))
    (setq r (cdr (assoc 40 e1)))
    (command "TRIM" ss "" (cadr e) "")
    (setq e2 (entget (car e)))
    (setq c (cdr (assoc 50 e2)))
    (setq d (cdr (assoc 51 e2)))
    (cond ((equal e1 e2)
           (command "CHANGE" (cdar e1) "" "P" "LAYER" lln "")
          )
          ((and (equal a c) (/= b d) (equal el (entlast)))
           (command "ARC" (polar cen d r)
                          "c" cen
                          (polar cen b r)
           )
          )
          ((and (equal b d) (/= a c) (equal el (entlast)))
           (command "ARC" (polar cen a r)
                          "c" cen
                          (polar cen c r)
           )
          )
          (T
           (setq x (cdr (assoc 50 (entget (entlast)))))
           (setq y (cdr (assoc 51 (entget (entlast)))))
           (cond ((and (equal a c) (equal b y))
                  (command "ARC" (polar cen d r)
                                 "c" cen
                                 (polar cen x r)
                  )
                 )
           )
          )
    )
    (command "LAYER" "S" cl "")
)
;;------------------------------------------------------------------------
;;   
(defun XCIRCLE (/ cen r)
    (command "LAYER" "S" lln "")
    (setq el (entlast))
    (setq cen (cdr (assoc 10 e1)))
    (setq r (cdr (assoc 40 e1)))
    (command "TRIM" ss "" (cadr e) "")
    (setq e2 (entget (car e)))
    (cond  ((equal e1 e2)
            (command "CHANGE" (cdar e1) "" "P" "LAYER" lln "")
           )
           ((= (cdr (assoc 0 e2)) "ARC")
            (setq r (cdr (assoc 40 e2)))
            (setq cen (cdr (assoc 10 e2)))
            (setq a (polar cen (cdr (assoc 50 e2)) r))
            (setq b (polar cen (cdr (assoc 51 e2)) r))
            (command "ARC" b "c" cen a)
           )
    )
    (command "LAYER" "S" cl "")
)
;;------------------------------------------------------------------------
;;   
(defun XLINE ()
    (command "LAYER" "S" lln "")
    (setq a (cdr (assoc 10 e1)))
    (setq b (cdr (assoc 11 e1)))
    (command "TRIM" ss "" (cadr e) "")
    (setq e2 (entget (car e)))
    (setq c (cdr (assoc 10 e2)))
    (setq d (cdr (assoc 11 e2)))
    (cond ((equal e1 e2)
           (command "CHANGE" (cdar e1) "" "P" "LAYER" lln "")
          )
          ((and (equal a c) (/= b d) (equal el (entlast)))
           (command "LINE" d b "")
          )
          ((and (equal b d) (/= a c) (equal el (entlast)))
           (command "LINE" a c "")
          )
          (T
           (setq x (cdr (assoc 10 (entget (entlast)))))
           (setq y (cdr (assoc 11 (entget (entlast)))))
           (cond ((and (equal a c) (equal b y))
                  (command "LINE" d x "")
                 )
           )
          )
    )
    (command "LAYER" "S" cl "")
)

;;------------------------------------------------------------------------
;;------------------------------------------------------------------------
(defun C:TRIMHALF (/ cen r e el e1 e2 a b c cl d ln ss yn x y osm)

  (modes '("CMDECHO" "BLIPMODE" "HIGHLIGHT" "OSMODE"))
  
  (setq cl (getvar "CLAYER")
       osm (getvar "OSMODE")
  )
  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 0)
  (setvar "OSMODE" 0)

  (if (null lln) (setq lln cl))
;;;  (while (null ln)
;;;         (setq ln (getstring (strcat
;;;                         "\n    <"
;;;                          lln
;;;                          ">: "
;;;                              )
;;;                  )
;;;         )
;;;         (if (= ln "") (setq ln lln))
;;;         (if (not (tblsearch "LAYER" ln))
;;;             (progn
;;;              (initget "Yes No")
;;;              (setq prmpt (strcat "\n "
;;;                                  (strcase ln t)
;;;                                  "  . ? <N>: "
;;;                          )
;;;              )
;;;              (setq yn (getkword prmpt))
;;;              (if (= yn "Y")
;;;                  (command "-LAYER" "Make" ln "")
;;;                  (setq ln nil)
;;;              )
;;;             )
;;;         )
;;;  )
  
  (setq ln ($getLayerName lln))
  (setq lln ln)
  
  (print "  ")
  (setq ss (ssget))
;  (setvar "HIGHLIGHT" 0)
  (setq e (entsel "\n  : "))
  (while e
    (setq e1 (entget (car e)))
    (setq el (entlast))
    (cond  ((= (cdr (assoc 0 e1)) "LINE")
            (xline)
           )
           ((= (cdr (assoc 0 e1)) "ARC")
            (xarc)
           )
           ((= (cdr (assoc 0 e1)) "CIRCLE")
            (xcircle)
           )
           (T (prompt "\n . "))
    )
    (setq e (entsel "\n  : "))
  )
 (moder)
 (setvar "OSMODE" osm)
 (princ)
)
;;;-------------------------------------------------------------------







